using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized; 
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;


namespace Model
{
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(280, 216);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridGroupingControl1.VersionInfo = "3.201.1.0";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private enum Days {Sat, Sun, Mon, Tue, Wed, Thu, Fri};

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");
			dt.Columns.Add("Col1",System.Type.GetType("System.String"));
			dt.Columns.Add("Col2",System.Type.GetType("System.Int32"));
			dt.Columns.Add("Col3",typeof(Days));

			DataRow dr ;
			for(int i = 1;i < 10;i++)
			{
				dr = dt.NewRow();
				dr[0] = "Col1Row"+i.ToString();
				if(i % 2 == 0)
					dr[1] = 3;
				else
					dr[1] = 5;
				
				dr[2] = Days.Fri; 
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;

			#region Setting the NewFilterBar celltype to the Grid.....
			Syncfusion.Windows.Forms.Grid.GridModel gm = new GridModel();;
			GridTableFilterBarCellModel1 g = new GridTableFilterBarCellModel1(gm);
			this.gridGroupingControl1.TableControl.Model.CellModels.Add("FilterBarCell1",g);
			#endregion

			#region Turn ON the AutoFilterRow...
			this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
			#endregion

			#region Turn ON the FilterCell.
			this.gridGroupingControl1.TableDescriptor.Columns["Col1"].AllowFilter = true;
			this.gridGroupingControl1.TableDescriptor.Columns["Col2"].AllowFilter = true;
			this.gridGroupingControl1.TableDescriptor.Columns["Col3"].AllowFilter = true;
			#endregion

			this.gridGroupingControl1.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo); 
			
			
		}

		#region Setting the CustomFilterList to column 3....
		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			if(	e.TableCellIdentity.ColIndex == 3  
				&& e.Style.CellType == "FilterBarCell" )
			{
				e.Style.CellType = "FilterBarCell1"; 
				StringCollection sc = new StringCollection();
				sc.AddRange(Enum.GetNames(typeof(Days))); 
				e.Style.ChoiceList = sc;
			}
		}
		#endregion


	}
	

	#region GridTableFilterBarCellModel1 class
	public class GridTableFilterBarCellModel1: GridTableFilterBarCellModel
	{
		public GridTableFilterBarCellModel1(Syncfusion.Windows.Forms.Grid.GridModel gm):base(gm){}

		#region for setting the CustomList in a Filter bar cell.
		public override void FillWithChoices(ListBox listBox, GridStyleInfo style, out bool exclusive)
		{
			Console.WriteLine(style.CellValueType);  
			if( style.ChoiceList != null )
			{
				exclusive = true;
				listBox.Items.Clear(); 
				listBox.Items.AddRange(new object[]{"(All)","(Custom)","(Empty)"});
				foreach( string s in style.ChoiceList)
					listBox.Items.Add(s);
			}
			else
				base.FillWithChoices(listBox,style,out exclusive);   
		}
		#endregion

		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{	return new Cellrenderer(control, this); }
	}
	#endregion

	#region Cellrenderer class
	public class Cellrenderer : GridTableFilterBarCellRenderer
	{
		public  Cellrenderer(GridControlBase grid, GridCellModelBase cellModel): base(grid , cellModel)	{}
		
		public new GridTableFilterBarCellModel1 Model
		{
			get
			{
				return (GridTableFilterBarCellModel1) base.Model;
			}
		}

		#region Setting the SelectedFilterText and RecordFilter
		protected override void ListBoxMouseUp(object sender, MouseEventArgs e)
		{
			if( this.StyleInfo.ChoiceList != null )
			{
				CurrentCell.CloseDropDown(PopupCloseType.Done);
				GridTableCellStyleInfo tableStyleInfo = (GridTableCellStyleInfo) this.StyleInfo;
				GridTableCellStyleInfoIdentity tableCellIdentity = tableStyleInfo.TableCellIdentity;
				

				int FieldIndex = tableCellIdentity.Table.TableDescriptor.ColIndexToField(tableCellIdentity.ColIndex);   
				string ColumnName = tableCellIdentity.Table.TableDescriptor.Columns[FieldIndex].MappingName;
				string SelectedValue = this.ListBoxPart.SelectedItem.ToString();

				if( SelectedValue != "(All)" 
					&& SelectedValue != "(Empty)" 
					&& SelectedValue != "(Custom)")
				{
					if( tableCellIdentity.Table.TableDescriptor.RecordFilters.Contains(ColumnName))
						tableCellIdentity.Table.TableDescriptor.RecordFilters.Remove(ColumnName);
					DataTable dt = tableCellIdentity.Table.Engine.DataSource as DataTable;    
					if( dt != null && dt.Columns[ColumnName].DataType.BaseType  == typeof(Enum))   
					{
						object obj = Enum.Parse(dt.Columns[ColumnName].DataType,SelectedValue,true);
						tableCellIdentity.Table.TableDescriptor.RecordFilters.Add(ColumnName,FilterCompareOperator.Equals,obj);     
					}
					else
                        tableCellIdentity.Table.TableDescriptor.RecordFilters.Add(ColumnName,FilterCompareOperator.Equals,SelectedValue);     
					StyleInfo.Text = SelectedValue;
					SetTextBoxText(GetFilterBarText(StyleInfo), false);
				}
				else
					base.ListBoxMouseUp(sender ,e); 
			}
			else
				base.ListBoxMouseUp(sender ,e); 
			
		}
		#endregion
			

	}		
	#endregion
}
